/// <reference types="ignite-ui" />
import { ElementRef, Renderer, IterableDiffers } from "@angular/core";
import { IgControlBase } from "../igcontrolbase/igcontrolbase";
export declare class IgDoughnutChartComponent extends IgControlBase<IgDoughnutChart> {
    constructor(el: ElementRef, renderer: Renderer, differs: IterableDiffers);
    /**
     * Adds a new series to the doughnut chart.
     *
     * @param seriesObj     The series object to be added.
     */
    addSeries(seriesObj: Object): void;
    /**
     * Removes the specified series from the doughnut chart.
     *
     * @param seriesObj     The series object identifying the series to be removed.
     */
    removeSeries(seriesObj: Object): void;
    /**
     * Updates the series with the specified name with the specified new property values.
     *
     * @param value     The series object identifying the series to be updated.
     */
    updateSeries(value: Object): void;
    /**
     * Returns the center of the doughnut chart.
     */
    getCenterCoordinates(): Object;
    /**
     * Returns the radius of the chart's hole.
     */
    getHoleRadius(): number;
    /**
     * Returns information about how the doughnut chart is rendered.
     */
    exportVisualData(): Object;
    /**
     * Causes all of the series that have pending changes e.g. by changed property values to be rendered immediately.
     */
    flush(): void;
    /**
     * Destroys the widget.
     */
    destroy(): void;
}
