/// <reference types="ignite-ui" />
import { Renderer, ElementRef, IterableDiffers } from "@angular/core";
import { IgEditorBase } from "./igeditorbase";
import { NgModel } from "@angular/forms";
export declare class IgCurrencyEditorComponent extends IgEditorBase<IgCurrencyEditor> {
    model: NgModel;
    constructor(el: ElementRef, renderer: Renderer, differs: IterableDiffers, model: NgModel);
    /**
     * Gets/sets a string that is used as the currency symbol shown with the number in the input. The value provided as a param is propagated to the currencySymbol option and thus has the same priority as the option.
     *
     * @param symbol     New currency symbol.
     */
    currencySymbol(symbol?: Object): string;
}
