/// <reference types="ignite-ui" />
import { ElementRef, Renderer, IterableDiffers } from "@angular/core";
import { IgEditorBase } from "./igeditorbase";
import { NgModel } from "@angular/forms";
export declare class IgDatePickerComponent extends IgEditorBase<IgDatePicker> {
    model: NgModel;
    constructor(el: ElementRef, renderer: Renderer, differs: IterableDiffers, model: NgModel);
    /**
     * Returns a reference to the jQuery calendar used as a picker selector
     */
    getCalendar(): string;
    dropDownContainer(): void;
    findListItemIndex(): void;
    getSelectedListItem(): void;
    selectedListIndex(): void;
    /**
     * Shows the drop down list.
     */
    showDropDown(): void;
    /**
     * Hides the drop down list.
     */
    hideDropDown(): void;
    /**
     * Returns a reference to the calendar button UI element of the editor.
     */
    dropDownButton(): string;
    /**
     * Returns the visibility state of the calendar.
     */
    dropDownVisible(): boolean;
    /**
     * Destroys the widget
     */
    destroy(): void;
}
