/// <reference types="ignite-ui" />
import { IgEditorBase } from "./igeditorbase";
import { Renderer, IterableDiffers, ElementRef } from "@angular/core";
import { NgModel } from "@angular/forms";
export declare class IgMaskEditorComponent extends IgEditorBase<IgMaskEditor> {
    model: NgModel;
    constructor(el: ElementRef, renderer: Renderer, differs: IterableDiffers, model: NgModel);
    /**
     * Gets/Sets mask editor value.
     *
     * @param newValue     New mask editor value.
     */
    value(newValue?: string): string;
    dropDownContainer(): void;
    showDropDown(): void;
    hideDropDown(): void;
    dropDownButton(): void;
    spinUpButton(): void;
    spinDownButton(): void;
    dropDownVisible(): void;
    findListItemIndex(): void;
    selectedListIndex(): void;
    getSelectedListItem(): void;
    spinUp(): void;
    spinDown(): void;
    /**
     * Checks if the value in the editor is valid. Note: This function will not trigger automatic notifications.
     */
    isValid(): boolean;
}
