/// <reference types="ignite-ui" />
import { Renderer, ElementRef, IterableDiffers } from "@angular/core";
import { IgEditorBase } from "./igeditorbase";
import { NgModel } from "@angular/forms";
export declare class IgNumericEditorComponent extends IgEditorBase<IgNumericEditor> {
    model: NgModel;
    constructor(el: ElementRef, renderer: Renderer, differs: IterableDiffers, model: NgModel);
    /**
     * Gets/Sets editor value.
     *
     * @param newValue     New editor value.
     */
    value(newValue?: number): number;
    /**
     * Finds index of list item by text that matches with the search parameters.
     *
     * @param number     The text to search for.
     */
    findListItemIndex(number: number): number;
    getSelectedText(): void;
    getSelectionStart(): void;
    getSelectionEnd(): void;
    /**
     * Increments value in editor according to the parameter.
     *
     * @param delta     Increments value.
     */
    spinUp(delta?: number): void;
    /**
     * Decrements value in editor according to the parameter.
     *
     * @param delta     Decrement value.
     */
    spinDown(delta?: number): void;
    /**
     * Moves the hovered index to the item that appears above the current one in the list.
     */
    selectListIndexUp(): void;
    /**
     * Moves the hovered index to the item that appears above the current one in the list.
     */
    selectListIndexDown(): void;
    /**
     * Gets current regional.
     */
    getRegionalOption(): string;
}
