/// <reference types="ignite-ui" />
import { Renderer, ElementRef, IterableDiffers } from "@angular/core";
import { IgEditorBase } from "./igeditorbase";
import { NgModel } from "@angular/forms";
export declare class IgPercentEditorComponent extends IgEditorBase<IgPercentEditor> {
    model: NgModel;
    constructor(el: ElementRef, renderer: Renderer, differs: IterableDiffers, model: NgModel);
    /**
     * Paste text at location of the caret or over the current selection. Best used during editing, as the method will instead set the text as value (modified by the [displayFactor](ui.igpercenteditor#options:displayFactor)) if the editor is not focused.
     * 				Note: the method raises the [textChanged](ui.igpercenteditor#events:textChanged) event.
     *
     * @param string     The string to be inserted.
     */
    insert(string: string): void;
    /**
     * Gets/Sets a string that is used as the percent symbol shown with the number in the input. The value provided as a param is propagated to the [percentSymbol](ui.igpercenteditor#options:percentSymbol) option and thus has the same priority as the option.
     *
     * @param symbol     New percent symbol.
     */
    percentSymbol(symbol?: Object): string;
}
