/// <reference types="ignite-ui" />
import { ElementRef, Renderer, IterableDiffers } from "@angular/core";
import { IgControlBase } from "../igcontrolbase/igcontrolbase";
export declare class IgFunnelChartComponent extends IgControlBase<IgFunnelChart> {
    constructor(el: ElementRef, renderer: Renderer, differs: IterableDiffers);
    /**
     * Gets array of selected slice items.
     *
     * @param selection     Array or selected slice items.
     * @return array|object     If parameter is undefined, then array of selected items is returned. Otherwise, it returns reference to igFunnelChart.
     */
    selectedSliceItems(selection?: any[]): any[];
    /**
     * Gets sets array of indexes of selected slices.
     *
     * @param selection     Array or selected slice indexes.
     * @return array|object     If parameter is undefined, then array of selected indexes is returned. Otherwise, it returns reference to igFunnelChart.
     */
    selectedSliceIndexes(selection?: any[]): any[];
    /**
     * Checks if slice is selected.
     *
     * @param slice     Index of slice or reference to slice-data-item.
     */
    isSelected(slice: Object): boolean;
    /**
     * Toggles selected state of slice.
     *
     * @param slice     Index of slice or reference to slice-data-item.
     */
    toggleSelection(slice: Object): Object;
    exportVisualData(): void;
    /**
     * Destroys widget.
     */
    destroy(): void;
}
