/// <reference types="ignite-ui" />
import { ElementRef, Renderer, IterableDiffers } from "@angular/core";
import { IgControlBase } from "../igcontrolbase/igcontrolbase";
export declare class IgPopoverComponent extends IgControlBase<IgPopover> {
    constructor(el: ElementRef, renderer: Renderer, differs: IterableDiffers);
    ngOnInit(): void;
    /**
     * Destroys the popover widget.
     */
    destroy(): void;
    /**
     * Returns the ID of the element the popover is attached to
     */
    id(): string;
    /**
     * Returns the container for the popover contents
     */
    container(): Object;
    /**
     * Shows the popover for the specified target
     *
     * @param trg     The element to show popover for.
     * @param content     The string to set for the popover to show.
     */
    show(trg?: Element, content?: string): void;
    /**
     * Hides the popover for the specified target
     */
    hide(): void;
    /**
     * Gets the currently set content for the popover container
     */
    getContent(): string;
    /**
     * Sets the content for the popover container
     *
     * @param newCnt     The popover content to set.
     */
    setContent(newCnt: string): void;
    /**
     * Gets the popover current target
     */
    target(): Object;
    /**
     * Gets the current coordinates of the popover
     */
    getCoordinates(): Object;
    /**
     * Sets the popover to specific coordinates.
     *
     * @param pos     The popover coordinates in pixels.
     */
    setCoordinates(pos: Object): void;
}
