/// <reference types="ignite-ui" />
import { ElementRef, Renderer, IterableDiffers } from "@angular/core";
import { IgControlBase } from "../igcontrolbase/igcontrolbase";
export declare class IgSchedulerComponent extends IgControlBase<IgScheduler> {
    constructor(el: ElementRef, renderer: Renderer, differs: IterableDiffers);
    /**
     * Gets reference to appointment by id
     *
     * @param id
     */
    getAppointmentById(id: Object): Object;
    /**
      * Creates a new appointment and renders it to the scheduler
     *
     * @param appointment
     */
    createAppointment(appointment: Object): Object;
    /**
      * Deletes appointment from the appointment collection
     *
     * @param appointment	appointment
     */
    deleteAppointment(appointment: Object): Object;
    /**
      * Deletes appointment from the appointment collection
     *
     * @param appointment	appointment
     * @param updateAppoinment	updateAppoinment
     */
    editAppointment(appointment: Object, updateAppoinment: Object): Object;
    /**
      * Destroys the widget
     */
    destroy(): void;
    /**
      * Gets reference to the today UI button.
     */
    todayButton(): string;
    /**
      * Gets reference to the previous UI button.
     */
    previousButton(): string;
    /**
      * Gets reference to the date range UI button.
     */
    dateRangeButton(): string;
    /**
      * Gets reference to the next UI button.
     */
    nextButton(): string;
    /**
      * Gets reference to the jQuery calendar UI control.
     */
    getCalendar(): string;
}
