/// <reference types="ignite-ui" />
import { ElementRef, Renderer, IterableDiffers } from "@angular/core";
import { IgControlBase } from "../igcontrolbase/igcontrolbase";
export declare class IgSplitButtonComponent extends IgControlBase<IgSplitButton> {
    constructor(el: ElementRef, renderer: Renderer, differs: IterableDiffers);
    /**
     * Switch to given igToolbar button.
     *
     * @param button . The button jQuery element.
     */
    switchToButton(button: Object): void;
    /**
     * Toggle widget state between collapsed and expanded.
     *
     * @param e The igSplitButton to be expanded/collapsed.
     */
    toggle(e: Object): Object;
    /**
     * Collapse the widget.
     *
     * @param e Indicates the browser event which triggered this action (not API).
     */
    collapse(e?: Object): Object;
    /**
     * Expands the widget.
     *
     * @param e Indicates the browser event which triggered this action (not API).
     */
    expand(e?: Object): Object;
    /**
     * Destroy the widget.
     */
    destroy(): void;
    widget(): void;
}
