/// <reference types="ignite-ui" />
import { ElementRef, Renderer, IterableDiffers } from "@angular/core";
import { IgContentControlBase } from "../igcontrolbase/igcontentcontrolbase";
export declare class IgSplitterComponent extends IgContentControlBase<IgSplitter> {
    constructor(el: ElementRef, renderer: Renderer, differs: IterableDiffers);
    /**
     * Returns the element that represents this widget.
     */
    widget(): Object;
    /**
     * Expand the specified panel by index.
     *
     * @param index Specifies the index of the panel to expand.
     */
    expandAt(index: Object): void;
    /**
     * Collapse the specified panel.
     *
     * @param index Specifies the index of the panel to collapse.
     */
    collapseAt(index: Object): void;
    /**
     * Retrieves the jQuery element of the first panel.
     */
    firstPanel(): Object;
    /**
     * Retrieves the jQuery element of the second panel.
     */
    secondPanel(): Object;
    /**
     * Refresh splitter layout, use this method to re-render the splitter if some changes to the layout are applied.
     */
    refreshLayout(): void;
    /**
     * You can set new size of the first panel after the splitter is rendered.
     *
     * @param size Specifies the new size of the first panel.
     */
    setFirstPanelSize(size: Object): void;
    /**
     * You can set new size of the second panel after the splitter is rendered.
     *
     * @param size Specifies the new size of the second panel.
     */
    setSecondPanelSize(size: Object): void;
    /**
     * Destroys the igSplitter widget
     */
    destroy(): void;
}
