"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var igcontrolbase_1 = require("../igcontrolbase/igcontrolbase");
var IgValidatorComponent = /** @class */ (function (_super) {
    __extends(IgValidatorComponent, _super);
    function IgValidatorComponent(el, renderer, differs) {
        return _super.call(this, el, renderer, differs) || this;
    }
    IgValidatorComponent.prototype.ngOnInit = function () {
        var evtName;
        this._el = jQuery(document).find("#" + this.widgetId);
        jQuery(this._el)[this._widgetName](this._config);
        this._events = new Map();
        //events binding
        var that = this;
        for (var propt in jQuery.ui[this._widgetName].prototype.events) {
            evtName = this._widgetName.toLowerCase() + propt.toLowerCase();
            this._events[evtName] = propt;
            jQuery(this._el).on(evtName, function (evt, ui) {
                that[that._events[evt.type]].emit({ event: evt, ui: ui });
            });
        }
    };
    /**
     * Trigger validation and show errors for invalid fields.
     *
     * @param field    Optional field object, its selector or zero-based index to check. Only has effect with fields collection and skips other fields.
     */
    /**
         * Trigger validation and show errors for invalid fields.
         *
         * @param field    Optional field object, its selector or zero-based index to check. Only has effect with fields collection and skips other fields.
         */
    IgValidatorComponent.prototype.validate = /**
         * Trigger validation and show errors for invalid fields.
         *
         * @param field    Optional field object, its selector or zero-based index to check. Only has effect with fields collection and skips other fields.
         */
    function (field) { return; };
    ;
    /**
     * Trigger validation but do not display error messages.
     *
     * @param field    Optional field object, its selector or zero-based index to check. Only has effect with fields collection and skips other fields.
     */
    /**
         * Trigger validation but do not display error messages.
         *
         * @param field    Optional field object, its selector or zero-based index to check. Only has effect with fields collection and skips other fields.
         */
    IgValidatorComponent.prototype.isValid = /**
         * Trigger validation but do not display error messages.
         *
         * @param field    Optional field object, its selector or zero-based index to check. Only has effect with fields collection and skips other fields.
         */
    function (field) { return; };
    ;
    /**
     * Hide any possible message(s) (either messageTarget or igNotifier).
     * 			Note: When the validator has a fields colleciton, not passing a field will hide messages on all fields.
     *
     * @param field    Optional field object, its selector or zero-based index to hide message for.
     */
    /**
         * Hide any possible message(s) (either messageTarget or igNotifier).
         * 			Note: When the validator has a fields colleciton, not passing a field will hide messages on all fields.
         *
         * @param field    Optional field object, its selector or zero-based index to hide message for.
         */
    IgValidatorComponent.prototype.hide = /**
         * Hide any possible message(s) (either messageTarget or igNotifier).
         * 			Note: When the validator has a fields colleciton, not passing a field will hide messages on all fields.
         *
         * @param field    Optional field object, its selector or zero-based index to hide message for.
         */
    function (field) { return; };
    ;
    /**
     * Gets all current error messages for invalid field(s). Note that this method does not valdiate and states and messages are only updated on validation, so
     * 			this can be used on formValidated event or after validate/isValid method calls.
     *
     * @param field    Optional field object, selector or zero-based index for a single field to get error message for.
     */
    /**
         * Gets all current error messages for invalid field(s). Note that this method does not valdiate and states and messages are only updated on validation, so
         * 			this can be used on formValidated event or after validate/isValid method calls.
         *
         * @param field    Optional field object, selector or zero-based index for a single field to get error message for.
         */
    IgValidatorComponent.prototype.getErrorMessages = /**
         * Gets all current error messages for invalid field(s). Note that this method does not valdiate and states and messages are only updated on validation, so
         * 			this can be used on formValidated event or after validate/isValid method calls.
         *
         * @param field    Optional field object, selector or zero-based index for a single field to get error message for.
         */
    function (field) { return; };
    ;
    /**
     * Check for currently displayed message(s). Takes an optional field.
     * 			Note: When the validator has a fields colleciton, not passing a field will return a cumulative true even if just one field has a visible message.
     *
     * @param field    Optional field object, selector or zero-based index for a single field to get error message for.
     */
    /**
         * Check for currently displayed message(s). Takes an optional field.
         * 			Note: When the validator has a fields colleciton, not passing a field will return a cumulative true even if just one field has a visible message.
         *
         * @param field    Optional field object, selector or zero-based index for a single field to get error message for.
         */
    IgValidatorComponent.prototype.isMessageDisplayed = /**
         * Check for currently displayed message(s). Takes an optional field.
         * 			Note: When the validator has a fields colleciton, not passing a field will return a cumulative true even if just one field has a visible message.
         *
         * @param field    Optional field object, selector or zero-based index for a single field to get error message for.
         */
    function (field) { return; };
    ;
    /**
     * Gets the notifier for the igValidator or for a single filed.
     *
     * @param field    Optional field object, its selector or zero-based index to get notifier for.
     */
    /**
         * Gets the notifier for the igValidator or for a single filed.
         *
         * @param field    Optional field object, its selector or zero-based index to get notifier for.
         */
    IgValidatorComponent.prototype.notifier = /**
         * Gets the notifier for the igValidator or for a single filed.
         *
         * @param field    Optional field object, its selector or zero-based index to get notifier for.
         */
    function (field) { return; };
    ;
    /**
     * Adds an new input to the fields collection and initializes it with the validator. Note: Additional fields are only accepted if the validator has been created with the collection.
     *
     * @param field    An object with the field selector and options.
     */
    /**
         * Adds an new input to the fields collection and initializes it with the validator. Note: Additional fields are only accepted if the validator has been created with the collection.
         *
         * @param field    An object with the field selector and options.
         */
    IgValidatorComponent.prototype.addField = /**
         * Adds an new input to the fields collection and initializes it with the validator. Note: Additional fields are only accepted if the validator has been created with the collection.
         *
         * @param field    An object with the field selector and options.
         */
    function (field) { return; };
    ;
    /**
     * Removes an input from the fields collection.
     *
     * @param field    The field object to remove, its zero-based index or selector.
     */
    /**
         * Removes an input from the fields collection.
         *
         * @param field    The field object to remove, its zero-based index or selector.
         */
    IgValidatorComponent.prototype.removeField = /**
         * Removes an input from the fields collection.
         *
         * @param field    The field object to remove, its zero-based index or selector.
         */
    function (field) { return; };
    ;
    /**
     * Updates a field in the validator collection. Used to reinitialize field in case a control has been created after the validator or to pass in new options.
     *
     * @param field    The field object to update, its zero-based index or selector.
     * @param fieldOptions    New options to apply to the field.
     */
    /**
         * Updates a field in the validator collection. Used to reinitialize field in case a control has been created after the validator or to pass in new options.
         *
         * @param field    The field object to update, its zero-based index or selector.
         * @param fieldOptions    New options to apply to the field.
         */
    IgValidatorComponent.prototype.updateField = /**
         * Updates a field in the validator collection. Used to reinitialize field in case a control has been created after the validator or to pass in new options.
         *
         * @param field    The field object to update, its zero-based index or selector.
         * @param fieldOptions    New options to apply to the field.
         */
    function (field, fieldOptions) { return; };
    ;
    /**
     * Destroys the validator widget.
     */
    /**
         * Destroys the validator widget.
         */
    IgValidatorComponent.prototype.destroy = /**
         * Destroys the validator widget.
         */
    function () { return; };
    ;
    IgValidatorComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: "ig-validator",
                    template: "<ng-content></ng-content>",
                    inputs: ["widgetId", "options", "changeDetectionInterval", "disabled", "create", "onchange", "onblur", "onsubmit", "required", "number", "date", "email", "lengthRange", "valueRange", "creditCard", "pattern", "messageTarget", "errorMessage", "successMessage", "threshold", "equalTo", "custom", "fields", "notificationOptions", "requiredIndication", "optionalIndication"],
                    outputs: ["validating", "validated", "success", "error", "errorShowing", "errorHiding", "errorShown", "errorHidden", "successShowing", "successHiding", "successShown", "successHidden", "formValidating", "formValidated", "formError", "formSuccess"]
                },] },
    ];
    /** @nocollapse */
    IgValidatorComponent.ctorParameters = function () { return [
        { type: core_1.ElementRef, },
        { type: core_1.Renderer, },
        { type: core_1.IterableDiffers, },
    ]; };
    return IgValidatorComponent;
}(igcontrolbase_1.IgControlBase));
exports.IgValidatorComponent = IgValidatorComponent;
//# sourceMappingURL=igvalidator.component.js.map